'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*!
                                                                                                                                                                                                                                                                   * Sheetrock
                                                                                                                                                                                                                                                                   * Quickly connect to, query, and lazy-load data from Google Sheets.
                                                                                                                                                                                                                                                                   * https://chriszarate.github.io/sheetrock/
                                                                                                                                                                                                                                                                   * License: MIT
                                                                                                                                                                                                                                                                   */

/* global window */

var _options = require('./lib/options');

var _options2 = _interopRequireDefault(_options);

var _request = require('./lib/request');

var _request2 = _interopRequireDefault(_request);

var _response = require('./lib/response');

var _response2 = _interopRequireDefault(_response);

var _config = require('./lib/config');

var _transport = require('./lib/transport');

var _transport2 = _interopRequireDefault(_transport);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Shimmed with 'transport-browser' in browser.

var version = '1.1.0';

function sheetrock() {
  var userOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

  var options = null;
  var request = null;
  var response = null;

  // Call the user's callback function or rethrow error.
  function handleError(error) {
    if (error && error.name === 'SheetrockError') {
      if (request && request.update) {
        request.update({ failed: true });
      }
    }

    if (userOptions.callback) {
      userOptions.callback(error, options, response);
      return;
    }

    if (error) {
      throw error;
    }
  }

  try {
    options = new _options2.default(_extends({ target: this }, userOptions), !!data);
    request = new _request2.default(options);
    response = new _response2.default(request);
  } catch (error) {
    handleError(error);
  }

  if (data) {
    response.loadData(data, handleError);
  } else if (options && request && response) {
    (0, _transport2.default)(response, handleError);
  }

  return this;
}

_extends(sheetrock, { defaults: _config.defaults, version: version });

// If jQuery is available as a global, register as a plugin.
try {
  window.jQuery.fn.sheetrock = sheetrock;
} catch (ignore) {/* empty */}

exports.default = sheetrock;
module.exports = exports['default'];