'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _error = require('./error');

var _error2 = _interopRequireDefault(_error);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* global window */

var headElement = window.document.getElementsByTagName('head')[0];
var callbackIndex = 0;

function get(response, callback) {
  var scriptElement = window.document.createElement('script');
  var callbackName = '_sheetrock_callback_' + callbackIndex;
  callbackIndex += 1;

  function always() {
    headElement.removeChild(scriptElement);
    delete window[callbackName];
  }

  function success(data) {
    always();
    response.loadData(data, callback);
  }

  function error() {
    always();
    callback(new _error2.default('Request failed.'));
  }

  window[callbackName] = success;

  if (scriptElement.addEventListener) {
    scriptElement.addEventListener('error', error, false);
    scriptElement.addEventListener('abort', error, false);
  }

  scriptElement.type = 'text/javascript';
  scriptElement.src = response.request.url + '&tqx=responseHandler:' + callbackName;
  headElement.appendChild(scriptElement);
}

exports.default = get;
module.exports = exports['default'];